function GMean = GridExploreRSVM(Label, data, UDTable, Params,Nweight,Pweight,id)
%--------------------------------------------------------------------------
% under designated parameters values, calculate GMean
% Inputs:
% Label     [r x 1]: training data label
% data      [r x c]: training data inputs
% id        If id=1: SVM and WSVM are being used, if id=2: WRSVM is being used
% Outputs:
% GMean      [m x n]: GMean 
%--------------------------------------------------------------------------
% w = size(data,2);                  
% l = size(data,1);      
classes = Label;              
Attributes  = data;

m = size(UDTable,1); 
GMean = zeros(m, 1);
Sen = zeros(m, 1);
Spe = zeros(m, 1);
Ac = zeros(m, 1);
  
% Cross Validation : 10-fold cross validatio
 
   
%for i = 1:10

%     test = [];
%     train_l = [];
%     test_l = [];
%     testdata = [];
%     traindata = [];
    r=randperm(numel(classes));     %chooses rows randomly and put it in matrix r
    tot=floor(numel(classes)*.9);   % 90% data is chosen for train, 10% for test
%     train=(r(1:tot));               %train=data(r(1:tot),:);
    train_l=classes(r(1:tot));      %train lables
    traindata=Attributes(r(1:tot),:);
%     weighttrain = wieghts(tot,1);
%     weighttrain = weight(r(1:tot));
    
    test = (r(tot+3:end)); 
    test_l = classes(r(tot+3:end));
    testdata = Attributes(r(tot+3:end),:);
    
    idx = find(classes == 1);         % To have label = 1 in testdata
    fg = randperm(numel(idx));
    mm = idx(fg(1)); 
    test = [test mm];      
    test_l = [test_l; 1];
    testdata = [testdata; Attributes(mm,:)];      
    
    Nidx = find(classes == -1);       % To have label = -1 in testdata
    Nfg = randperm(numel(Nidx));
    mm = Nidx(Nfg(1));
    test = [test mm];      
    test_l = [test_l; -1];
    testdata = [testdata; Attributes(mm,:)];
    
for x=1:m
   Params.c=2^UDTable(x, 1);
   Params.g=2^UDTable(x, 2);
   b=0;
   c=0;
   ROC=zeros(2,2);
   
    
        if id==1
            model = svmtrain(train_l,traindata,['-s 0 -t 2 -c '  num2str(Params.c) ' -g ' num2str(Params.g) '-e' 0.1]);    %c 1000 -g 0.015618
            [predict_label , accuracy, prob_estimates] = svmpredict(test_l,testdata, model,'-q');
        end
        if id==2
%           model = svmtrain(weighttrain,train_l,traindata,['-s 0 -t 2 -c '  num2str(Params.c) ' -g ' num2str(Params.g) '-q']);    %c 1000 -g 0.015618
            model = svmtrain(train_l,traindata,['-s 0 -t 2 -c '  num2str(Params.c) ' -g ' num2str(Params.g) '-w-1' num2str(Nweight) '-w1' num2str(Pweight) '-e' 0.1]);    %c 1000 -g 0.015618
            
            [predict_label , accuracy, prob_estimates] = svmpredict(test_l,testdata, model,'-q');            
        end
        
        % Accuracy
        Ac(x)=sum(predict_label==test_l)/size(test_l,1);
               
        % sensitivity & Specificity
        for j=1:numel(test_l)
            if test_l(j)==-1
                if predict_label(j)==-1
                    ROC(1,1)=ROC(1,1)+1;
                end
                if predict_label(j)==1
                    ROC(2,1)=ROC(2,1)+1;
                end
            end
            
            if test_l(j)==1
                if predict_label(j)==-1
                    ROC(1,2)=ROC(1,2)+1;
                end
                if predict_label(j)==1
                    ROC(2,2)=ROC(2,2)+1;
                end
            end
        end

        b = ROC(1,1)+ROC(2,1);
        Sen(x) = ROC(1,1)/b;
        c = ROC(2,2)+ROC(1,2);
        Spe(x) = ROC(2,2)/c;
   
%end
GMean(x) = sqrt(Sen(x)*Spe(x));
end


             

 
  
 