clear all;
close all;
tic;
resu = struct;
% %------Input for both minority class and majority class KNN graphs-----
resu.KNN = 10;                                % Number of neighbors
resu.KNN_UNCOARSE = 10;
resu.Param_bag = 300;                        % The size of subsets in clustering      
resu.U_trainsize = 3000;                     % The limit for training data size
resu.MoS_UB = 500;                           % In ModelSelction.m if the size of traindata(n) is greater than MoS_UB, stop doing model section and just inherit C and Gamma from previous level     
resu.Upperlim = 500;                         % Maximum size of data in each class for training
resu.Imb_size = 300;                         % If the size of each class is less than Imb_size, then do the coarsening. This parameter is used in MLD.m
resu.per_num = 0.01;                         % Percentage of the nearest clusters for rach cluster in the list
resu.M_LOOP_clusters = 1;                    % The number of iterations for getting support vectors in clusters
resu.Multilevel = 1;                         % If you use multilevel algorithm, set Multilevel=1 else Multilevel=0
resu.Model_Selec = 1;                        % If you use model selection, set Model_Selec = 1 else Model_Selec = 0 (As defualt C = 100 and gamma = 0.5 in ModelSelection.m)
resu.Have_test = 0;                          % If we have separate testdata and traindata files, Have_test = 1 else Have_test = 0 (In this case, we choose 90% for training and 10% for testing)
%----------Load data-----------
    load twonorm;  
%------------------------------
resu.coarse = 0;
resu.Level_size = 1;                         % # of levels
if resu.Have_test == 0
    data = sparse(data);
    lbl = sparse(lbl);
    %-----------------------------------------------------------------
    %sprintf('data loaded\n')
    
    data = zscore(data);       % Normalize data
    %whos data
    %sprintf('data normalized\n')
    [Pdata,Ndata,Plbl,Nlbl] = Imbalanced(data,lbl,1);   % To divide the dataset into minority(Pdata,Plbl) and majority(Ndata,Nlbl) class
    %sprintf('data imbalanced\n')
    Ndata = sparse(Ndata);
    Pdata = sparse(Pdata);
    clear data;
    %sprintf('data normalized and separated\n')
    % ---------Returns kNN similarity graph of majority class----------
    
    for ite =1:1
        level = 0;                        % # of levels
        ite
        r = randperm(numel(Nlbl));        % chooses rows randomly and put it in matrix r
        tot = floor(numel(Nlbl)*.9);      % 90% data is chosen for train, 10% for test, tot: majority class size
        Ntrainlbl = Nlbl(r(1:tot));        % train lables
        Ntraindata = Ndata(r(1:tot),:);
        NVhat = r(1:tot);
        NVhat1 = 1:size(NVhat,2);                % Comment this line for no multilevel
        %----------------------------------------------------------------------
        s = randperm(numel(Plbl));        %chooses rows randomly and put it in matrix r
        sot = floor(numel(Plbl)*.9);      % 90% data is chosen for train, 10% for test,s sot: minority class size
        Ptrainlbl = Plbl(s(1:sot));        %train lables
        Ptraindata = Pdata(s(1:sot),:);
        PVhat = s(1:sot);                       % Comment this line for no multilevel
        PVhat1 = 1:size(PVhat,2);               % Comment this line for no multilevel
        
        Pweight = 1/size(Ptraindata,1);                       % The inverse size of minority class
        Nweight = 1/size(Ntraindata,1);                       % The inverse size of majority class
        train_l = [Ntrainlbl; Ptrainlbl];
        traindata = [Ntraindata; Ptraindata];
        
        test_l = [Nlbl(r(tot+1:end)); Plbl(s(sot+1:end))];
        testdata = [Ndata(r(tot+1:end),:); Pdata(s(sot+1:end),:)];
        
        %-----------------Creat KNN Graph---------------------
        % tic;
        %sprintf('before knn for maj\n')
        if resu.Multilevel == 1
            [nresult, ndists] = flann_search(Ntraindata', Ntraindata', resu.KNN, struct('algorithm','composite',...
                'branching',32,...
                'iterations',3,...
                'trees', 1,...
                'checks',64));
           %sprintf('after knn for maj\n') 
           %whos nresult
            % [nresult, ndists] = flann_search(Ntraindata', Ntraindata', KNN, struct('algorithm','kmeans',...
            %                                                          'branching',32,...
            %                                                          'iterations',3,...
            %                                                          'checks',120));
            
            
            %  [nresult, ndists] = flann_search(Ntraindata', Ntraindata', KNN, struct('algorithm','kdtree',...
            %                                                           'trees',8,...
            %                                                       'checks',64));
            
            %NAD1 = zeros(size(Ntraindata,1),size(Ntraindata,1));
            NAD1 = sparse(size(Ntraindata,1), size(Ntraindata,1));
            for i=1:size(Ntraindata,1)
                NAD1(i,nresult(:,i)) = 1;
                %     NAD(result(:,i),i) = 1;
            end
            
             %sprintf('before knn for min\n')           
            % kNN search by MATLAB
            % [nresult,D] = knnsearch(Ntraindata,Ntraindata,'k',KNN);    % find 5 datapoints around each point
            %
            % NAD1 = zeros(size(Ntraindata,1),size(Ntraindata,1));
            % NAD1 = sparse(NAD1);
            % for i=1:size(Ntraindata,1)
            %     NAD1(i,nresult(i,:)) = 1;
            % %     NAD(result(:,i),i) = 1;
            % end
            
            % % Returns kNN similarity graph of minority class
            [presult, pdists] = flann_search(Ptraindata', Ptraindata', resu.KNN, struct('algorithm','composite',...
                'branching',32,...
                'iterations',3,...
                'trees', 1,...
                'checks',64));
            
            
            % [presult, pdists] = flann_search(Ptraindata', Ptraindata', KNN, struct('algorithm','kmeans',...
            %                                                          'branching',32,...
            %                                                          'iterations',3,...
            %                                                          'checks',120));
            
            %
            % [presult, pdists] = flann_search(Ptraindata', Ptraindata', KNN, struct('algorithm','kdtree',...
            %                                                           'trees',8,...
            %                                                           'checks',64));
            %
            %PAD1 = zeros(size(Ptraindata,1),size(Ptraindata,1));
            PAD1 = sparse(size(Ptraindata,1),size(Ptraindata,1));
            for i=1:size(Ptraindata,1)
                PAD1(i,presult(:,i)) = 1;
                %     PAD(result(:,i),i) = 1;
            end
                        
            % kNN search by MATLAB
            % [presult,D] = knnsearch(Ptraindata,Ptraindata,'k',KNN);    % find 5 datapoints around each point
            %
            % PAD1 = zeros(size(Ptraindata,1),size(Ptraindata,1));
            % PAD1 = sparse(PAD1);
            % for i=1:size(Ptraindata,1)
            %     PAD1(i,presult(i,:)) = 1;
            % %     NAD(result(:,i),i) = 1;
            % end
            
            % time_flann = toc;
            
            
            Edge_NAD = sum(sum(NAD1)) - size(NAD1,1);
            %Edge_NAD
            Node_NAD = size(NAD1,1);
            %Node_NAD
            
            Edge_PAD = sum(sum(PAD1)) - size(PAD1,1);
            %Edge_PAD
            Node_PAD = size(PAD1,1);
            %Node_PAD
            sprintf('0 %d %d %d %d', Node_NAD, Edge_NAD, Node_PAD  , Edge_PAD)
            
            nresult1 = nresult;
            presult1 = presult;
        end
        
        
       if resu.Multilevel == 1
            [resu.Gmean1(ite),resu.Gmean2(ite),resu.Sen1(ite),resu.Spe1(ite),resu.Acc1(ite),resu.Sen2(ite),resu.Spe2(ite),resu.Acc2(ite),SVData,SVlbl,resu.Level_size(ite),resu.BestC(ite),resu.BestG(ite),resu.BestWC(ite),resu.BestWG(ite)] = MLD(traindata,train_l,testdata,test_l,Ntraindata,Ntrainlbl,Ntraindata,Ntrainlbl,NAD1,Ptraindata,Ptrainlbl,Ptraindata,Ptrainlbl,PAD1,resu.Upperlim,Pweight,Nweight,resu.KNN,level,resu.KNN_UNCOARSE,nresult1,presult1,nresult,presult,resu.Param_bag,resu.U_trainsize,resu.per_num,resu.M_LOOP_clusters,resu.Model_Selec,resu.Imb_size,resu.coarse,resu.Multilevel,resu.MoS_UB,resu.Level_size);
            % resu.BestC,resu.BestG,resu.BestWC,resu.BestWG are the C and Gamma for the finest level for SVM and WSVM respectively
        else
            [resu.Sen1(ite),resu.Spe1(ite),resu.Acc1(ite),resu.Gmean1(ite),resu.Sen2(ite),resu.Spe2(ite),resu.Acc2(ite),resu.Gmean2(ite),SV_indices,resu.SVData,resu.SVlbl,resu.w,resu.b,resu.BestC,resu.BestG,resu.BestWC,resu.BestWG] = SVMandWSVM(traindata,train_l,testdata,test_l,Pweight,Nweight,resu.Model_Selec,resu.Multilevel,resu.MoS_UB,resu.coarse);
        end
        
    end
    
    [resu.GMean1,resu.GMean2,resu.Sensitivity1,resu.Sensitivity2,resu.Specificity1,resu.Specificity2,resu.Accuracy1,resu.Accuracy2,resu.stdGMean1,resu.stdGMean2,resu.stdSensitivity1,resu.stdSensitivity2,resu.stdSpecificity1,resu.stdSpecificity2,resu.stdAccuracy1,resu.stdAccuracy2] = AverageStat(resu.Gmean1,resu.Gmean2,resu.Sen1,resu.Spe1,resu.Acc1,resu.Sen2,resu.Spe2,resu.Acc2);
    resu.time_Code = toc;
       
else
    
    
    %----------Load data-----------
%     load ISOLET_Test;            %testdata
    load Hypothyroid_Test;
    
    data = sparse(data);
    lbl = sparse(lbl);
    testdata = zscore(data);
    test_l = lbl;                          
    %----------------------------------------------------------------------
%     load ISOLET_Train;           %traindata
    load Hypothyrid_Train;

    data = sparse(data);
    lbl = sparse(lbl);
    data = zscore(data);       % Normalize data
    [Pdata,Ndata,Plbl,Nlbl] = Imbalanced(data,lbl,1);   % To divide the dataset into minority(Pdata,Plbl) and majority(Ndata,Nlbl) class
    
    clear data;
    sprintf('data normalized and separated\n')
            
    Ntrainlbl = Nlbl;                        % train lables
    Ntraindata = sparse(Ndata);
    NVhat = 1:numel(Nlbl);        
    
    Ptrainlbl = Plbl;
    Ptraindata = sparse(Pdata);
    PVhat = 1:numel(Plbl);                           % Comment this line for no multilevel
    
    Pweight = 1/size(Ptraindata,1);                       % The inverse size of minority class
    Nweight = 1/size(Ntraindata,1);                       % The inverse size of majority class
    train_l = [Ntrainlbl; Ptrainlbl];
    traindata = [Ntraindata; Ptraindata];
   % ---------Returns kNN similarity graph of majority class----------
      for ite =1:1
        ite
        level = 0;      % # of levels
               %-----------------Creat KNN Graph---------------------
        % tic;
        %sprintf('before knn for maj\n')
        if resu.Multilevel == 1
            [nresult, ndists] = flann_search(Ntraindata', Ntraindata', resu.KNN, struct('algorithm','composite',...
                'branching',32,...
                'iterations',3,...
                'trees', 1,...
                'checks',64));
           %sprintf('after knn for maj\n') 
           %whos nresult
            % [nresult, ndists] = flann_search(Ntraindata', Ntraindata', KNN, struct('algorithm','kmeans',...
            %                                                          'branching',32,...
            %                                                          'iterations',3,...
            %                                                          'checks',120));
            
            
            %  [nresult, ndists] = flann_search(Ntraindata', Ntraindata', KNN, struct('algorithm','kdtree',...
            %                                                           'trees',8,...
            %                                                       'checks',64));
            
            %NAD1 = zeros(size(Ntraindata,1),size(Ntraindata,1));
            NAD1 = sparse(size(Ntraindata,1), size(Ntraindata,1));
            for i=1:size(Ntraindata,1)
                NAD1(i,nresult(:,i)) = 1;
                %     NAD(result(:,i),i) = 1;
            end
            
             %sprintf('before knn for min\n')           
            % kNN search by MATLAB
            % [nresult,D] = knnsearch(Ntraindata,Ntraindata,'k',KNN);    % find 5 datapoints around each point
            %
            % NAD1 = zeros(size(Ntraindata,1),size(Ntraindata,1));
            % NAD1 = sparse(NAD1);
            % for i=1:size(Ntraindata,1)
            %     NAD1(i,nresult(i,:)) = 1;
            % %     NAD(result(:,i),i) = 1;
            % end
            
            % % Returns kNN similarity graph of minority class
            [presult, pdists] = flann_search(Ptraindata', Ptraindata', resu.KNN, struct('algorithm','composite',...
                'branching',32,...
                'iterations',3,...
                'trees', 1,...
                'checks',64));
            
            
            % [presult, pdists] = flann_search(Ptraindata', Ptraindata', KNN, struct('algorithm','kmeans',...
            %                                                          'branching',32,...
            %                                                          'iterations',3,...
            %                                                          'checks',120));
            
            %
            % [presult, pdists] = flann_search(Ptraindata', Ptraindata', KNN, struct('algorithm','kdtree',...
            %                                                           'trees',8,...
            %                                                           'checks',64));
            %
            %PAD1 = zeros(size(Ptraindata,1),size(Ptraindata,1));
            PAD1 = sparse(size(Ptraindata,1),size(Ptraindata,1));
            for i=1:size(Ptraindata,1)
                PAD1(i,presult(:,i)) = 1;
                %     PAD(result(:,i),i) = 1;
            end
                        
            % kNN search by MATLAB
            % [presult,D] = knnsearch(Ptraindata,Ptraindata,'k',KNN);    % find 5 datapoints around each point
            %
            % PAD1 = zeros(size(Ptraindata,1),size(Ptraindata,1));
            % PAD1 = sparse(PAD1);
            % for i=1:size(Ptraindata,1)
            %     PAD1(i,presult(i,:)) = 1;
            % %     NAD(result(:,i),i) = 1;
            % end
            
            % time_flann = toc;
            
            
            Edge_NAD = sum(sum(NAD1)) - size(NAD1,1);
            %Edge_NAD
            Node_NAD = size(NAD1,1);
            %Node_NAD
            
            Edge_PAD = sum(sum(PAD1)) - size(PAD1,1);
            %Edge_PAD
            Node_PAD = size(PAD1,1);
            %Node_PAD
            sprintf('0 %d %d %d %d', Node_NAD, Edge_NAD, Node_PAD  , Edge_PAD)
            
            nresult1 = nresult;
            presult1 = presult;
        end
        %-------------------------------------------
       
        if resu.Multilevel == 1
               [resu.Gmean1(ite),resu.Gmean2(ite),resu.Sen1(ite),resu.Spe1(ite),resu.Acc1(ite),resu.Sen2(ite),resu.Spe2(ite),resu.Acc2(ite),SVData,SVlbl,resu.Level_size(ite),resu.BestC(ite),resu.BestG(ite),resu.BestWC(ite),resu.BestWG(ite)] = MLD(traindata,train_l,testdata,test_l,Ntraindata,Ntrainlbl,Ntraindata,Ntrainlbl,NAD1,Ptraindata,Ptrainlbl,Ptraindata,Ptrainlbl,PAD1,resu.Upperlim,Pweight,Nweight,resu.KNN,level,resu.KNN_UNCOARSE,nresult1,presult1,nresult,presult,resu.Param_bag,resu.U_trainsize,resu.per_num,resu.M_LOOP_clusters,resu.Model_Selec,resu.Imb_size,resu.coarse,resu.Multilevel,resu.MoS_UB,resu.Level_size);
        else
            [resu.Sen1(ite),resu.Spe1(ite),resu.Acc1(ite),resu.Gmean1(ite),resu.Sen2(ite),resu.Spe2(ite),resu.Acc2(ite),resu.Gmean2(ite),resu.SV_indices,resu.SVData,resu.SVlbl,resu.w,resu.b,resu.BestC,resu.BestG,resu.BestWC,resu.BestWGG] = SVMandWSVM(traindata,train_l,testdata,test_l,Pweight,Nweight,resu.Model_Selec,resu.Multilevel,resu.MoS_UB,resu.coarse);
        end
        
    end
    
    [resu.GMean1,resu.GMean2,resu.Sensitivity1,resu.Sensitivity2,resu.Specificity1,resu.Specificity2,resu.Accuracy1,resu.Accuracy2,resu.stdGMean1,resu.stdGMean2,resu.stdSensitivity1,resu.stdSensitivity2,resu.stdSpecificity1,resu.stdSpecificity2,resu.stdAccuracy1,resu.stdAccuracy2] = AverageStat(resu.Gmean1,resu.Gmean2,resu.Sen1,resu.Spe1,resu.Acc1,resu.Sen2,resu.Spe2,resu.Acc2);
    resu.time_Code = toc;

end

    
        %                     if size(data,2)==2
        %                         plot(PDataVhat1(:,1),PDataVhat1(:,2),'.r');hold on;
        %                         plot(NDataVhat1(:,1),NDataVhat1(:,2),'.b');
        %                     end